//
//  ViewController.m
//  Waterfalls
//
//  Created by lovingc2009 on 2018/5/30.
//  Copyright © 2018年 lovingc2009. All rights reserved.
//

#import "ViewController.h"
#import "YHOCollectionView.h"
#import "YHOWaterfallBuilder.h"

@interface ViewController ()
@property (weak, nonatomic) IBOutlet YHOCollectionView *collectionView;

@end

@implementation ViewController

#define LOAD_COUNT 20

- (IBAction)buttonClicked:(id)sender {
    
    float array[LOAD_COUNT];
    NSMutableArray *testImagesScale = @[].mutableCopy;
    
    for (int i=0; i<LOAD_COUNT; i++) {
        CGFloat imageWidth = (50. + arc4random()%150);
        CGFloat imageHeight = 100.;
        array[i] = imageWidth/imageHeight;
        [testImagesScale addObject:@(array[i])];
    }
    
    NSArray *sizes = [YHOWaterfallBuilder generateSizesWithScales:testImagesScale];
    [self.collectionView.cacheSizes addObjectsFromArray:sizes];
    
    for (int i=0; i<LOAD_COUNT; i++) {
        CGFloat r = (CGFloat)(random()%255)/255.;
        CGFloat g = (CGFloat)(random()%255)/255.;
        CGFloat b = (CGFloat)(random()%255)/255.;
        [self.collectionView.cellBackgroundColors addObject:[UIColor colorWithRed:r green:g blue:b alpha:1]];
    }
    
    [self.collectionView reloadData];
}

@end
