//
//  YHOCollectionView.m
//  Waterfalls
//
//  Created by lovingc2009 on 2018/5/30.
//  Copyright © 2018年 lovingc2009. All rights reserved.
//

#import "YHOCollectionView.h"

static NSString * const reuseIdentifier = @"Cell";

@interface YHOCollectionView()<UICollectionViewDelegate, UICollectionViewDataSource>

@end

@implementation YHOCollectionView

- (void)awakeFromNib{
    [super awakeFromNib];
    [self registerClass:[UICollectionViewCell class] forCellWithReuseIdentifier:reuseIdentifier];
    self.dataSource = self;
    self.delegate = self;
    self.cellBackgroundColors = [NSMutableArray array];
    self.cacheSizes = [NSMutableArray array];
}

- (NSInteger)numberOfSectionsInCollectionView:(UICollectionView *)collectionView{
    return 1;
}

- (NSInteger)collectionView:(UICollectionView *)collectionView numberOfItemsInSection:(NSInteger)section{
    return self.cellBackgroundColors.count;
}

- (UICollectionViewCell *)collectionView:(UICollectionView *)collectionView cellForItemAtIndexPath:(NSIndexPath *)indexPath {
    
    UICollectionViewCell *cell = [collectionView dequeueReusableCellWithReuseIdentifier:reuseIdentifier forIndexPath:indexPath];
    
    // Configure the cell
    cell.contentView.backgroundColor = self.cellBackgroundColors[indexPath.row];
    
    return cell;
}

- (UIEdgeInsets)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout insetForSectionAtIndex:(NSInteger)section{
    CGFloat width = 1;
    return UIEdgeInsetsMake(width, 0, 0, 0);
}

- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout minimumLineSpacingForSectionAtIndex:(NSInteger)section{
    CGFloat width = 1.8;
    return width;
}

- (CGFloat)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout*)collectionViewLayout minimumInteritemSpacingForSectionAtIndex:(NSInteger)section{
    CGFloat width = 1.25;
    return width;
}

- (CGSize)collectionView:(UICollectionView *)collectionView layout:(UICollectionViewLayout *)collectionViewLayout sizeForItemAtIndexPath:(NSIndexPath *)indexPath {

    CGSize size = [(NSNumber *)[self.cacheSizes
                                objectAtIndex:indexPath.row] CGSizeValue];
    return CGSizeMake(collectionView.frame.size.width * size.width - 1, collectionView.frame.size.width * size.height - 1);
}



@end
